#                                                                -*-Autoconf-*-
# asciidoc.m4: asciidoc generation rules.
# Copyright (C) 2010 by Thomas Moulard, CNRS.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Additional permission under section 7 of the GNU General Public
# License, version 3 ("GPLv3"):
#
# If you convey this file as part of a work that contains a
# configuration script generated by Autoconf, you may do so under
# terms of your choice.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# serial 1

# ------ #
# README #
# ------ #

# This m4 file can be used to enable asciidoc support in Autoconf.

m4_pattern_forbid([^JRL_])

# JRL_PROG_ASCIIDOC([VARIABLE], [VERSION_MIN])
# -----------------------------------------------------
# Check that asciidoc and its dependencies are available and is
# newer thatn VERSION_MIN
AC_DEFUN([JRL_PROG_ASCIIDOC],
[AC_CHECK_PROGS([$1], [asciidoc],
	       AC_MSG_ERROR([failed to find asciidoc.]))

# Required by asciidoc for source code syntax highlighting.
AC_CHECK_PROGS([SOURCE_HIGHLIGHT], [source-highlight],
	       AC_MSG_ERROR([Failed to find source-highlight.]))

ASCIIDOC_REQUIRED_VERSION=$2
AC_MSG_CHECKING([asciidoc is at least version $ASCIIDOC_REQUIRED_VERSION])
ASCIIDOC_VERSION=`asciidoc --version 2> /dev/null | sed 's/^asciidoc //'`

for i in 1 2 3; do
 if test -z "$asciidoc_version_ok"; then
  wantedversion=`echo "$ASCIIDOC_REQUIRED_VERSION" | cut -d'.' -f$i`
  version=`echo "$ASCIIDOC_VERSION" | cut -d'.' -f$i`

  if test $version -lt $wantedversion; then
   asciidoc_version_ok=no
  fi
  if test $version -gt $wantedversion; then
   asciidoc_version_ok=yes
  fi
 fi
done

if test x"$asciidoc_version_ok" = xno; then
 AC_MSG_RESULT([no])
else
 AC_MSG_RESULT([yes])
fi
])
